Package ghidra.util.database

# Class DBCachedObjectStoreKeySet

java.lang.Object
ghidra.util.database.DBCachedObjectStoreKeySet

All Implemented Interfaces:
  `Iterable<Long>`, `Collection<Long>`, `NavigableSet<Long>`, `SequencedCollection<Long>`, `SequencedSet<Long>`, `Set<Long>`, `SortedSet<Long>`

Direct Known Subclasses:
  `DBCachedObjectStoreKeySubSet`

public class DBCachedObjectStoreKeySet extends Object implements NavigableSet<Long>
This provides the implementation of `Map.keySet()` for `DBCachedObjectStore.asMap()`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected final DirectedIterator.Direction`
  `direction`
  `protected final ErrorHandler`
  `errHandler`
  `protected final ReadWriteLock`
  `lock`
  `protected final DBCachedObjectStore<?>`
  `store`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DBCachedObjectStoreKeySet(DBCachedObjectStore<?> store, ErrorHandler errHandler, ReadWriteLock lock, DirectedIterator.Direction direction)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `add(Long e)`
  `boolean`
  `addAll(Collection<? extends Long> c)`
  `Long`
  `ceiling(Long e)`
  `void`
  `clear()`
  `Comparator<? super Long>`
  `comparator()`
  `boolean`
  `contains(Object o)`
  `boolean`
  `containsAll(Collection<?> c)`
  `Iterator<Long>`
  `descendingIterator()`
  `DBCachedObjectStoreKeySet`
  `descendingSet()`
  `Long`
  `first()`
  `Long`
  `floor(Long e)`
  `DBCachedObjectStoreKeySubSet`
  `headSet(Long toElement)`
  `DBCachedObjectStoreKeySubSet`
  `headSet(Long toElement, boolean inclusive)`
  `Long`
  `higher(Long e)`
  `boolean`
  `isEmpty()`
  `Iterator<Long>`
  `iterator()`
  `Long`
  `last()`
  `Long`
  `lower(Long e)`
  `Long`
  `pollFirst()`
  `Long`
  `pollLast()`
  `boolean`
  `remove(Object o)`
  `boolean`
  `removeAll(Collection<?> c)`
  `boolean`
  `retainAll(Collection<?> c)`
  `int`
  `size()`
  `DBCachedObjectStoreKeySubSet`
  `subSet(Long fromElement, boolean fromInclusive, Long toElement, boolean toInclusive)`
  `DBCachedObjectStoreKeySubSet`
  `subSet(Long fromElement, Long toElement)`
  `DBCachedObjectStoreKeySubSet`
  `tailSet(Long fromElement)`
  `DBCachedObjectStoreKeySubSet`
  `tailSet(Long fromElement, boolean inclusive)`
  `Object[]`
  `toArray()`
  `<T> T[]`
  `toArray(T[] a)`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface java.util.Collection

  `parallelStream, removeIf, stream, toArray`

  ### Methods inherited from interface java.lang.Iterable

  `forEach`

  ### Methods inherited from interface java.util.NavigableSet

  `removeFirst, removeLast, reversed`

  ### Methods inherited from interface java.util.Set

  `equals, hashCode`

  ### Methods inherited from interface java.util.SortedSet

  `addFirst, addLast, getFirst, getLast, spliterator`

- ## Field Details

  - ### store

    protected final DBCachedObjectStore<?> store

  - ### errHandler

    protected final ErrorHandler errHandler

  - ### lock

    protected final ReadWriteLock lock

  - ### direction

    protected final DirectedIterator.Direction direction

- ## Constructor Details

  - ### DBCachedObjectStoreKeySet

    public DBCachedObjectStoreKeySet(DBCachedObjectStore<?> store, ErrorHandler errHandler, ReadWriteLock lock, DirectedIterator.Direction direction)

- ## Method Details

  - ### size

    public int size()
    Specified by:
      `size` in interface `Collection<Long>`
    Specified by:
      `size` in interface `Set<Long>`

  - ### isEmpty

    public boolean isEmpty()
    Specified by:
      `isEmpty` in interface `Collection<Long>`
    Specified by:
      `isEmpty` in interface `Set<Long>`

  - ### contains

    public boolean contains(Object o)
    Specified by:
      `contains` in interface `Collection<Long>`
    Specified by:
      `contains` in interface `Set<Long>`

  - ### iterator

    public Iterator<Long> iterator()
    Specified by:
      `iterator` in interface `Collection<Long>`
    Specified by:
      `iterator` in interface `Iterable<Long>`
    Specified by:
      `iterator` in interface `NavigableSet<Long>`
    Specified by:
      `iterator` in interface `Set<Long>`

  - ### toArray

    public Object[] toArray()
    Specified by:
      `toArray` in interface `Collection<Long>`
    Specified by:
      `toArray` in interface `Set<Long>`

  - ### toArray

    public <T> T[] toArray(T[] a)
    Specified by:
      `toArray` in interface `Collection<Long>`
    Specified by:
      `toArray` in interface `Set<Long>`

  - ### add

    public boolean add(Long e)
    Specified by:
      `add` in interface `Collection<Long>`
    Specified by:
      `add` in interface `Set<Long>`

  - ### remove

    public boolean remove(Object o)
    Specified by:
      `remove` in interface `Collection<Long>`
    Specified by:
      `remove` in interface `Set<Long>`

  - ### containsAll

    public boolean containsAll(Collection<?> c)
    Specified by:
      `containsAll` in interface `Collection<Long>`
    Specified by:
      `containsAll` in interface `Set<Long>`

  - ### addAll

    public boolean addAll(Collection<? extends Long> c)
    Specified by:
      `addAll` in interface `Collection<Long>`
    Specified by:
      `addAll` in interface `Set<Long>`

  - ### retainAll

    public boolean retainAll(Collection<?> c)
    Specified by:
      `retainAll` in interface `Collection<Long>`
    Specified by:
      `retainAll` in interface `Set<Long>`

  - ### removeAll

    public boolean removeAll(Collection<?> c)
    Specified by:
      `removeAll` in interface `Collection<Long>`
    Specified by:
      `removeAll` in interface `Set<Long>`

  - ### clear

    public void clear()
    Specified by:
      `clear` in interface `Collection<Long>`
    Specified by:
      `clear` in interface `Set<Long>`

  - ### comparator

    public Comparator<? super Long> comparator()
    Specified by:
      `comparator` in interface `SortedSet<Long>`

  - ### first

    public Long first()
    Specified by:
      `first` in interface `SortedSet<Long>`

  - ### last

    public Long last()
    Specified by:
      `last` in interface `SortedSet<Long>`

  - ### lower

    public Long lower(Long e)
    Specified by:
      `lower` in interface `NavigableSet<Long>`

  - ### floor

    public Long floor(Long e)
    Specified by:
      `floor` in interface `NavigableSet<Long>`

  - ### ceiling

    public Long ceiling(Long e)
    Specified by:
      `ceiling` in interface `NavigableSet<Long>`

  - ### higher

    public Long higher(Long e)
    Specified by:
      `higher` in interface `NavigableSet<Long>`

  - ### pollFirst

    public Long pollFirst()
    Specified by:
      `pollFirst` in interface `NavigableSet<Long>`

  - ### pollLast

    public Long pollLast()
    Specified by:
      `pollLast` in interface `NavigableSet<Long>`

  - ### descendingSet

    public DBCachedObjectStoreKeySet descendingSet()
    Specified by:
      `descendingSet` in interface `NavigableSet<Long>`

  - ### descendingIterator

    public Iterator<Long> descendingIterator()
    Specified by:
      `descendingIterator` in interface `NavigableSet<Long>`

  - ### subSet

    public DBCachedObjectStoreKeySubSet subSet(Long fromElement, boolean fromInclusive, Long toElement, boolean toInclusive)
    Specified by:
      `subSet` in interface `NavigableSet<Long>`

  - ### headSet

    public DBCachedObjectStoreKeySubSet headSet(Long toElement, boolean inclusive)
    Specified by:
      `headSet` in interface `NavigableSet<Long>`

  - ### tailSet

    public DBCachedObjectStoreKeySubSet tailSet(Long fromElement, boolean inclusive)
    Specified by:
      `tailSet` in interface `NavigableSet<Long>`

  - ### subSet

    public DBCachedObjectStoreKeySubSet subSet(Long fromElement, Long toElement)
    Specified by:
      `subSet` in interface `NavigableSet<Long>`
    Specified by:
      `subSet` in interface `SortedSet<Long>`

  - ### headSet

    public DBCachedObjectStoreKeySubSet headSet(Long toElement)
    Specified by:
      `headSet` in interface `NavigableSet<Long>`
    Specified by:
      `headSet` in interface `SortedSet<Long>`

  - ### tailSet

    public DBCachedObjectStoreKeySubSet tailSet(Long fromElement)
    Specified by:
      `tailSet` in interface `NavigableSet<Long>`
    Specified by:
      `tailSet` in interface `SortedSet<Long>`